<?php
// $Horde: imp/config/prefs.php.dist,v 1.49.2.4 2001/11/22 18:14:00 jan Exp $

$prefGroups['personal'] = array(
    'column' => _("Your Information"),
    'label' => _("Personal Information"),
    'desc' => _("Change the name, address, and signature that people see when they read and reply to your email."),
    'members' => array('identityselect', 'default_identity', 'identity')
);

$prefGroups['server'] = array(
    'column' => _("Your Information"),
    'label' => _("Server Information"),
    'desc' => _("Change your mail server and folder information."),
    'members' => array('folders', 'trash_folder', 'subscribe')
);

$prefGroups['language'] = array(
    'column' => _("Your Information"),
    'label' => _("Language"),
    'desc' => _("Set the language that menu items, explanations, and help are in."),
    'members' => array('language')
);

$prefGroups['timezone'] = array(
    'column' => _("Your Information"),
    'label' => _("Time Zone"),
    'desc' => _("Set the current time zone."),
    'members' => array('timezone')
);

$prefGroups['filters'] = array(
    'column' => _("Mail Management"),
    'label' => _("Filters"),
    'desc' => _("Create filtering rules to organize your incoming mail, sort it into folders, and delete spam."),
    'members' => array('filters_link', 'filter_on_login', 'show_filter_msg')
);

$prefGroups['viewing'] = array(
    'column' => _("Mail Management"),
    'label' => _("Message Viewing"),
    'desc' => _("Set preferences for filtering messages for unwanted content."),
    'members' => array('filtering')
);

$prefGroups['delmove'] = array(
    'column' => _("Mail Management"),
    'label' => _("Deleting and Moving Messages"),
    'desc' => _("Set preferences for what happens when you move and delete messages."),
    'members' => array('mailbox_return', 'use_trash', 'trashselect')
);

$prefGroups['monthlytasks'] = array(
    'column' => _("Mail Management"),
    'label' => _("Maintenance Operations"),
    'desc' => _("Customize maintenance operations run upon login to IMP."),
    'members' => array('rename_sentmail_monthly', 'delete_sentmail_monthly',
                       'delete_sentmail_monthly_keep', 'purge_trash',
                       'purge_trash_interval', 'purge_trash_keep')
);

$prefGroups['display'] = array(
    'column' => _("Other Options"),
    'label' => _("Display Options"),
    'desc' => _("Change display options such as how many messages you see on each page and how messages are sorted."),
    'members' => array('sortby', 'sortdir', 'max_msgs', 'num_words',
                       'nav_expanded')
);

$prefGroups['compose'] = array(
    'column' => _("Other Options"),
    'label' => _("Message Composition"),
    'desc' => _("Customize how you send mail and where drafts are saved."),
    'members' => array('wrap_width', 'compose_popup', 'folderselect', 'drafts_folder')
);

$prefGroups['logintasks'] = array(
    'column' => _("Other Options"),
    'label' => _("Login Tasks"),
    'desc' => _("Customize tasks to run upon logon to IMP."),
    'members' => array('show_last_login')
);

$prefGroups['newmail'] = array(
    'column' => _("Other Options"),
    'label' => _("New Mail"),
    'desc' => _("Control when new mail will be checked for, and whether or not to notify you when it arrives."),
    'members' => array('refresh_time', 'nav_popup')
);

$prefGroups['addressbooks'] = array(
    'column' => _("Other Options"),
    'label' => _("Addressbooks"),
    'desc' => _("Select addressbook sources for adding and searching for addresses."),
    'members' => array('sourceselect')
);



// user language
$_prefs['language'] = array(
    'value' => 'en_EN',
    'locked' => false,
    'shared' => true,
    'type' => 'select',
    'desc' => _("Select your preferred language:")
);

// user time zone
$_prefs['timezone'] = array(
    'value' => '',
    'locked' => false,
    'shared' => true,
    'type' => 'select',
    'desc' => _("Your current time zone:")
);

// user folder path
$_prefs['folders'] = array(
    'value' => '',
    'locked' => false,
    'shared' => false,
    'type' => 'text',
    'desc' => _("Path to your mail folders:")
);

// user default mailbox
$_prefs['mailbox'] = array(
    'value' => 'INBOX',
    'locked' => false,
    'shared' => false,
    'type' => 'implicit'
);

// identities
// Don't change anything here.
$_prefs['identities'] = array(
    'value' => 'a:0:{}',
    'locked' => false,
    'shared' => true,
    'type' => 'implicit'
);

// default identity selection widget
$_prefs['identityselect'] = array('type' => 'special');

// default identity
// Set locked to true if you don't want the users to have multiple identities.
$_prefs['default_identity'] = array(
    'value' => 0,
    'locked' => false,
    'shared' => true,
    'type' => 'implicit'
);

// link to the identities ui
$_prefs['identity'] = array(
    'type' => 'link',
    'url' => 'identities.php',
    'img' => 'personal.gif',
    'desc' => _("Edit your identities")
);

// user signature
$_prefs['signature'] = array(
    'value' => '',
    'locked' => false,
    'shared' => true,
    'type' => 'implicit'
);

// preceed the signature with dashes ('-- ')?
$_prefs['sig_dashes'] = array(
    'value' => 0,
    'locked' => false,
    'shared' => true,
    'type' => 'implicit'
);

// signature before replies and forwards?
$_prefs['sig_first'] = array(
    'value' => 0,
    'locked' => false,
    'shared' => true,
    'type' => 'implicit'
);

// user full name for From: line
// see also $conf['hooks']['fullname'] in conf.php
$_prefs['fullname'] = array(
    'value' => '',
    'locked' => false,
    'shared' => true,
    'type' => 'implicit'
);

// user preferred email address for From: line
// see also $conf['hooks']['from'] in conf.php
$_prefs['from_addr'] = array(
    'value' => '',
    'locked' => false,
    'shared' => true,
    'type' => 'implicit'
);

// user preferred email address for Reply-To:, if different from From:
$_prefs['replyto_addr'] = array(
    'value' => '',
    'locked' => false,
    'shared' => true,
    'type' => 'implicit'
);

// save a copy of sent messages?
$_prefs['save_sent_mail'] = array(
    'value' => 1,
    'locked' => false,
    'shared' => true,
    'type' => 'implicit'
);

// sent mail folder
$_prefs['sent_mail_folder'] = array(
    'value' => 'sent-mail',
    'locked' => false,
    'shared' => true,
    'type' => 'implicit'
);

// user preferred sorting column
$_prefs['sortby'] = array(
    'value' => SORTARRIVAL,
    'locked' => false,
    'shared' => false,
    'type' => 'enum',
    'enum' => array(SORTARRIVAL => _("Arrival Time"),
                    SORTDATE => _("Message Date"),
                    SORTFROM => _("From Address"),
                    SORTSUBJECT => _("Subject Field"),
                    SORTSIZE => _("Message Size")),
    'desc' => _("Default sorting criteria:")
);

// user preferred sorting direction
$_prefs['sortdir'] = array(
    'value' => 0,
    'locked' => false,
    'shared' => false,
    'type' => 'enum',
    'enum' => array(0 => _("Ascending"),
                    1 => _("Descending")),
    'desc' => _("Default sorting direction:")
);

// mailbox constraints
$_prefs['max_msgs'] = array(
    'value' => 20,
    'locked' => false,
    'shared' => false,
    'type' => 'number',
    'desc' => _("Messages per page in the mailbox view.")
);

// number of spelling corrections per screen
$_prefs['num_words'] = array(
    'value' => 3,
    'locked' => false,
    'shared' => false,
    'type' => 'number',
    'desc' => _("Spelling errors per screen when spell checking.")
);

// hide deleted
$_prefs['delhide'] = array(
    'value' => 0,
    'locked' => false,
    'shared' => false,
    'type' => 'implicit'
);

// last login time of user
$_prefs['last_login'] = array(
    'value' => 0,
    'locked' => false,
    'shared' => false,
    'type' => 'implicit'
);

// show the last login time of user
$_prefs['show_last_login'] = array(
    'value' => 1,
    'locked' => false,
    'shared' => false,
    'type' => 'checkbox',
    'desc' => _("Show last login time when logging in")
);

// rename sent-mail folder every month?
$_prefs['rename_sentmail_monthly'] = array(
    'value' => 1,
    'locked' => false,
    'shared' => false,
    'type' => 'checkbox',
    'desc' => _("Rename sent-mail folder at beginning of month")
);

// purge sent-mail folders every month?
$_prefs['delete_sentmail_monthly'] = array(
    'value' => 0,
    'locked' => false,
    'shared' => false,
    'type' => 'checkbox',
    'desc' => _("Delete old sent-mail folders at beginning of month")
);

// how many old sent-mail folders to keep every month?
$_prefs['delete_sentmail_monthly_keep'] = array(
    'value' => 12,
    'locked' => false,
    'shared' => false,
    'type' => 'number',
    'desc' => _("Number of old sent-mail folders to keep if deleting monthly")
);

// purge Trash folder?
$_prefs['purge_trash'] = array(
    'value' => 1,
    'locked' => false,
    'shared' => false,
    'type' => 'checkbox',
    'desc' => _("Purge old message in the Trash folder")
);

// how often to purge the Trash folder?
// 'value': yearly = 1, monthly = 2, weekly = 3, daily = 4, every login = 5
$_prefs['purge_trash_interval'] = array(
    'value' => '2',
    'locked' => false,
    'shared' => false,
    'type' => 'select',
    'desc' => _("Purge Trash how often:")
);

// when purging Trash folder, purge messages older than how many days?
$_prefs['purge_trash_keep'] = array(
    'value' => 30,
    'locked' => false,
    'shared' => false,
    'type' => 'number',
    'desc' => _("Purge messages in Trash folder older than this amount of days")
);

// folder selection widget. includes some javascript, so it's specific
// to IMP.
$_prefs['folderselect'] = array('type' => 'special');

// drafts folder
$_prefs['drafts_folder'] = array(
    'value' => 'drafts',
    'locked' => false,
    'shared' => false,
    'type' => 'implicit'
);

// should we return to the mailbox listing after deleting a message?
$_prefs['mailbox_return'] = array(
    'value' => 0,
    'locked' => false,
    'shared' => false,
    'type' => 'checkbox',
    'desc' => _("Return to the mailbox listing after deleting, moving, or copying a message?")
);

// should we move messages to a trash folder instead of just marking
// them as deleted?
$_prefs['use_trash'] = array(
    'value' => 0,
    'locked' => false,
    'shared' => false,
    'type' => 'checkbox',
    'desc' => _("When deleting messages, move them to your Trash folder instead of marking them as deleted.")
);

// trash folder
$_prefs['trash_folder'] = array(
    'value' => 'trash',
    'locked' => false,
    'shared' => false,
    'type' => 'implicit'
);

// trash folder selection widget. includes some javascript, so it's
// specific to IMP.
$_prefs['trashselect'] = array('type' => 'special');

// use IMAP subscribe?
$_prefs['subscribe'] = array(
    'value' => 0,
    'locked' => false,
    'shared' => false,
    'type' => 'checkbox',
    'desc' => _("Use IMAP folder subscriptions")
);

// wrap text at this many characters
$_prefs['wrap_width'] = array(
    'value' => 80,
    'locked' => false,
    'shared' => false,
    'type' => 'number',
    'desc' => _("Wrap text at this many characters.")
);

// compose in a separate window?
$_prefs['compose_popup'] = array(
    'value' => 1,
    'locked' => false,
    'shared' => false,
    'type' => 'checkbox',
    'desc' => _("Compose messages in a separate window.")
);

// addressbook selection widget
$_prefs['sourceselect'] = array('type' => 'special');

// addressbook(s) to use when expanding addresses
$_prefs['search_sources'] = array(
    'value' => '',
    'locked' => false,
    'shared' => false,
    'type' => 'implicit'
);

// field(s) to use when expanding addresses
$_prefs['search_fields'] = array(
    'value' => '',
    'locked' => false,
    'shared' => false,
    'type' => 'implicit'
);

// addressbook to use for adding adresseses
$_prefs['add_source'] = array(
    'value' => '',
    'locked' => false,
    'shared' => false,
    'type' => 'implicit'
);

// filter message content?
$_prefs['filtering'] = array(
    'value' => 0,
    'locked' => false,
    'shared' => false,
    'type' => 'checkbox',
    'desc' => _("Filter message content for profanity.")
);

// expand folder tree by default
$_prefs['nav_expanded'] = array(
    'value' => 0,
    'locked' => false,
    'shared' => false,
    'type' => 'enum',
    'enum' => array(0 => _("No"),
                    1 => _("Yes"),
                    2 => _("Remember the last view")),
    'desc' => _("Expand the entire folder tree by default in the folders view.")
);

// list of folders to expand by default
$_prefs['expanded_folders'] = array(
    'value' => 'a:0:{}',
    'locked' => false,
    'shared' => false,
    'type' => 'implicit'
);

// list of folders to poll for new mail
$_prefs['nav_poll'] = array(
    'value' => '',
    'locked' => false,
    'shared' => false,
    'type' => 'implicit'
);

// time before reloading the navigator or mailbox page
$_prefs['refresh_time'] = array(
    'value' => 0,
    'locked' => false,
    'shared' => false,
    'type' => 'enum',
    'enum' => array(0 => _("Never"),
                    30 => _("Every 30 seconds"),
                    60 => _("Every minute"),
                    300 => _("Every 5 minutes"),
                    900 => _("Every 15 minutes"),
                    1800 => _("Every half hour")),
    'desc' => _("Refresh Folder Views:")
);

// javascript popup if there's new mail?
$_prefs['nav_popup'] = array(
    'value' => 0,
    'locked' => false,
    'shared' => false,
    'type' => 'checkbox',
    'desc' => _("Display pop-up notification of new mail.")
);

// mail filter rules options
$_prefs['filters'] = array(
    'value' => '',
    'locked' => false,
    'shared' => false,
    'type' => 'implicit'
);

$_prefs['filters_link'] = array(
    'type' => 'link',
    'url' => 'filters.php',
    'img' => 'filters.gif',
    'desc' => _("Edit my filter rules")
);

// run filters on login?
$_prefs['filter_on_login'] = array(
    'value' => 0,
    'locked' => false,
    'shared' => false,
    'type' => 'checkbox',
    'desc' => _("Apply filter rules upon logging on.")
);

// Show filter status messages?
$_prefs['show_filter_msg'] = array(
    'value' => 0,
    'locked' => false,
    'shared' => false,
    'type' => 'checkbox',
    'desc' => _("Display message when filters have been applied.")
);

?>
