<form method="post" name="compose" enctype="multipart/form-data" action="<?= Horde::url('compose.php?uniq=' . uniqid(rand())) ?>">

<?php
$count = 0;
if (!isset($error) || !is_array($error)) {
    $numerrors = 0;
} else {
    $numerrors = count($error);
}
$errorsleft = $numerrors;
if ($numerrors > 0) {
    for ($k = 0; $k < count($error); $k++) {
        if (isset($ignoreall)) {
            $ignores = explode(',', $ignoreall);
            if (member($error[$k][0],$ignores)) $errorsleft--;
        }
    }
}
$i = 0;
?>
<table width="100%" border="0" cellspacing="0" cellpadding="1">
  <tr class="header">
    <td colspan="8" class="header">
      <b>
<?php if ($errorsleft > 0): ?>
        <?= _("Spell Checker") ?> - <i><?= $errorsleft ?> <?php if ($errorsleft > 1) echo _("spelling errors"); else echo _("spelling error"); ?></i>
<?php else: ?>
        <?= _("Spell check complete") ?> - <?= _("No spelling errors") ?>
<?php endif; ?>
      </b>
    </td>
  </tr>
<?php
while ($count < $prefs->getValue('num_words') && $i < $numerrors) {
    if (!isset($error) || !is_array($error)) {
        echo _("Spell check complete");
        break;
    }
    if (isset($ignoreall)) {
        $ignores = explode(',', $ignoreall);
        if (member($error[$i][0],$ignores))
            $includeword = 0;
        else
            $includeword = 1;
	}
    else
        $includeword = 1;
    if ($includeword) {
?>

  <tr class="item">
    <td class="item"><?= _("Correct") ?></td>
    <td colspan="3" nowrap="nowrap">
<?php
    $offset = $error[$i][1];
    $word = $error[$i][0];
    $alt = $error[$i][2];
    echo '<font color="ff0000">"' . htmlspecialchars($word) . '"</font>';
    echo _(" in ");
    $context = highlight_error(htmlspecialchars($word), htmlspecialchars($f_message), htmlspecialchars($offset));
    if ($context != '')
        echo "<span class=\"fixed\">$context</span>";
    else
        echo _("none");
?>

    </td>
    <td><b><i><?= _("Change"); ?></i></b></td>
    <td><b><i><?= _("Change All"); ?></i></b></td>
    <td><?= _("Ignore") ?></td>
    <td><?= _("Ignore All") ?></td>
  </tr>
  <tr>
    <td class="item"><b><?= _("Suggestions") ?></b></td>
    <td class="item">
      <input type="hidden" name="oldword[<?= $count ?>]" value="<?= $word ?>" />
      <input type="hidden" name="wordoffset[<?= $count ?>]" value="<?= $offset ?>" />
      <select name="subs[<?= $count ?>]" onchange="change_selected(<?= $count ?>);">
<?php
if ($alt != '') {
    $checkedval = 3;
    $altwords = explode(', ', $alt);
    for ($j = 0; $j < count($altwords); $j++) {
        echo "<option value=\"$altwords[$j]\">$altwords[$j]</option>\n";
    }
} else {
    $checkedval = 3;
    echo '<option value="0">No suggestions</option>';
}
?></select>
    </td>
    <td class="item"><b><?php
  if ($alt != '')
    echo _("or");
  else
    echo _("Replace with:");
?></b></td>
    <td class="item"><input type="text" name="subtext[<?= $count ?>]" size="12" onchange="change_selected(<?= $count ?>);" /></td>
    <td class="item"><input type="radio" value="1" name="opt[<?= $count ?>]" <?php if ($checkedval == 1) echo 'checked="checked"'; ?> /></td>
    <td class="item"><input type="radio" value="2" name="opt[<?= $count ?>]" <?php if ($checkedval == 2) echo 'checked="checked"'; ?> /></td>
    <td class="item"><input type="radio" value="3" name="opt[<?= $count ?>]" <?php if ($checkedval == 3) echo 'checked="checked"'; ?> /></td>
    <td class="item"><input type="radio" value="4" name="opt[<?= $count ?>]" <?php if ($checkedval == 4) echo 'checked="checked"'; ?> /></td>
  </tr>
<?php
        $count++;
    }
    $i++;
}
?>
  <tr class="item">
    <td colspan="8" class="item">
      <input type="button" class="button" onclick="document.compose.actionID.value='<?= SPELL_CHECK_CANCEL ?>'; document.compose.submit();" value="<?= _("Cancel") ?>" /><i>&nbsp;<?= _("(Discard all changes and return to the compose screen.)") ?></i>
    </td>
  </tr>
<?php if ($actionID == SPELL_CHECK_FORWARD || $errorsleft == 0): ?>
  <tr class="item">
    <td colspan="8" class="item">
      <input type="button" class="button" onclick="document.compose.actionID.value='<?= SPELL_CHECK_DONE ?>'; document.compose.submit();" value="<?= _("Done") ?>" /><i>&nbsp;<?= _("(Return to the compose screen after applying all changes made thus far.  Changes on the current screen will NOT be applied.)") ?></i>
    </td>
  </tr>
<?php endif; ?>
<?php if ($errorsleft > 0): ?>
  <tr class="item">
    <td colspan="8" class="item">
      <input type="button" class="button" onclick="document.compose.actionID.value='<?= SPELL_CHECK_FORWARD ?>'; document.compose.submit();" value="<?= _("Next") ?>" /><i>&nbsp;<?= _("(Apply these changes and move to next screen.)") ?></i>
    </td>
  </tr>
<?php endif; ?>
  <tr><td colspan="8">&nbsp;</td></tr>
  <tr class="header"><td colspan="8" class="header"><b><?= _("Corrected Text") ?></b></td></tr>
  <tr><td colspan="8" class="item">
    <div class="fixed"><pre><?= htmlspecialchars($f_newmsg . $f_message) ?></pre></div>
  </td></tr>
</table>

<!-- Maintain lots of state -->
<input type="hidden" name="actionID" value="" />
<input type="hidden" name="spellcheck" value="" />
<input type="hidden" name="popup" value="<?= Horde::getFormData('popup', ''); ?>" />
<input type="hidden" name="index" value="<?php if (isset($index)) echo $index; ?>" />
<?php if (isset($is_reply)): ?><input type="hidden" name="is_reply" value="1" /><?php endif; ?>
<?php if (isset($in_reply_to)): ?><input type="hidden" name="in_reply_to" value="<?= $in_reply_to ?>" /><?php endif; ?>
<?php if (isset($references)): ?><input type="hidden" name="references" value="<?= $references ?>" /><?php endif; ?>
<input type="hidden" name="oldmsg" value="<?= htmlspecialchars($f_oldmsg) ?>" />
<input type="hidden" name="message" value="<?= htmlspecialchars($f_message) ?>" />
<input type="hidden" name="newmsg" value="<?= htmlspecialchars($f_newmsg) ?>" />
<input type="hidden" name="ignoreall" value="<?= htmlspecialchars($f_ignoreall) ?>" />
<input type="hidden" name="changeall" value="<?= Horde::getFormData('changeall') ?>" />
<input type="hidden" name="from" value="<?php if (isset($from)) echo htmlspecialchars($from) ?>" />
<input type="hidden" name="to" value="<?php if (isset($to)) echo htmlspecialchars($to) ?>" />
<input type="hidden" name="cc" value="<?php if (isset($cc)) echo htmlspecialchars($cc) ?>" />
<input type="hidden" name="bcc" value="<?php if (isset($bcc)) echo htmlspecialchars($bcc) ?>" />
<input type="hidden" name="subject" value="<?php if (isset($subject)) echo htmlspecialchars($subject) ?>" />

<!-- Attachment Form -->
<?php if (isset($HTTP_POST_VARS['attachments_name']) && is_array($HTTP_POST_VARS['attachments_name']) && count($HTTP_POST_VARS['attachments_name']) > 0): ?>
<?php for ($i = 0; $i < count($HTTP_POST_VARS['attachments_name']); $i++): ?>
<input type="hidden" name="attachments_name[]" value="<?= $HTTP_POST_VARS['attachments_name'][$i] ?>" />
<input type="hidden" name="attachments_size[]" value="<?= $HTTP_POST_VARS['attachments_size'][$i] ?>" />
<input type="hidden" name="attachments_file[]" value="<?= $HTTP_POST_VARS['attachments_file'][$i] ?>" />
<input type="hidden" name="attachments_type[]" value="<?= $HTTP_POST_VARS['attachments_type'][$i] ?>" />
<?php endfor; ?>
<?php endif; ?>

</form>
